#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#if 0
#include "Fcsolvex.h"
#else
#include "main.h"
#include "Fcsolve.h"
#endif
#include "fcs_user.h"
#include "fcs_cl.h"
//extern int signal_step(int) ;
int NumFCs ;
char * moves_string;
char * moves_stringe;
static const char * ranks_map = "0A23456789TJQK";

char szTemp[500] ;

static char * rank_to_string(int rank, char * buf)
{
    buf[0] = ranks_map[rank];
    buf[1] = '\0';
    return buf;
}

static const char * suits_map = "CDSH";

static char * suit_to_string(int suit, char * buf)
{
    buf[0] = suits_map[suit];
    buf[1] = '\0';
    return buf;
}

static char * card_to_string(Card card, char * buf)
{
    rank_to_string(card&0x0F,buf);
    suit_to_string(card>>4,buf+1);

    return buf;
}

static char * position_to_string(Position * pos, int num_freecells)
{
    int a, stack;
    char buffer[4000], temp[4][20];
    char * s_end;

    buffer[0] = '\0';
    s_end = buffer;

    for(a=0;a<4;a++)
    {
        if (pos->foundations[a] != 0)
        {
            break;
        }
    }
    if (a < 4)
    {
        s_end += sprintf(s_end, "Foundations:");
        for(a=0;a<4;a++)
        {
            if (pos->foundations[a] != 0)
            {
                s_end += sprintf(
                    s_end, 
                    " %s-%s", 
                    suit_to_string(a, temp[0]),
                    rank_to_string(pos->foundations[a], temp[1])
                    );
            }
        }
        *s_end = '\n';
        s_end++;
    }
    s_end += sprintf(s_end, "Freecells:");
    for(a=0;a<num_freecells;a++)
    {
        if (pos->hold[a] == 0)
        {
            s_end += sprintf(s_end, " -");
        }
        else
        {
            s_end += sprintf(s_end, " %s", card_to_string(pos->hold[a], temp[0]));
        }
    }
    *s_end = '\n';
    s_end++;

    for(stack=0;stack<8;stack++)
    {
        for(a=0;a<pos->tableau[stack].count;a++)
        {
           s_end += 
                sprintf(
                    s_end, 
                    "%s%s", 
                    ((a == 0)? "" : " "),
                    card_to_string(pos->tableau[stack].cards[a], temp[0])
                );                                
        }
        *s_end = '\n';
        s_end++;
    }
    *s_end = '\0';

    return strdup(buffer);
}



enum FCS_IFACE_MODES
{
    FCS_IFACE_MODE_DFS,
    FCS_IFACE_MODE_A_STAR,

    FCS_IFACE_MODE_OPT = 0x10000,
};
#ifdef FC89
int Cvtf89(int fcn)
{
	if ((NumFCs > 7) && (fcn >= 7))
		return (fcn+3) ;
	return fcn ;
}
#endif

BOOL ssind, ssind2 ;
int vcount ;
extern int mvinh ;
BOOL shind, fhind ;

static void render_vmove(fcs_move_t move, char * string)
{
	char c = string[2] ;
	sprintf(string, "%xv", 
          fcs_move_get_num_cards_in_seq(move)
          );
	ssind = FALSE ;			
	string[2] = c ;
}

static void render_move(fcs_move_t move, char * string)
{
    /* Save the third character which will be set to '\0' by the sprintf.
     * It's a kludge, but it works.
     * */
    char c = string[2];
	char b ;  //ABE
	ssind = FALSE ;
    switch(fcs_move_get_type(move))
    {
        case FCS_MOVE_TYPE_STACK_TO_STACK:
//		if (mvinh == 0)
//			{
			sprintf(string, "%i%i", 
                    1+fcs_move_get_src_stack(move),
                    1+fcs_move_get_dest_stack(move)
                    );
/*
			}
			else
			{
			sprintf(string, "xx");
			mvinh = 0 ;
			}
//			ssind2 = TRUE ;
*/
		if (dest_stack_len == 0)
				ssind = TRUE ;
		break;

        case FCS_MOVE_TYPE_FREECELL_TO_STACK:
				sprintf(string, "%c%i", 
#ifndef FC89
                    ('a'+fcs_move_get_src_freecell(move)),
#else
                    ('a'+Cvtf89(fcs_move_get_src_freecell(move))),
#endif
                    1+fcs_move_get_dest_stack(move)
                    );
		break;

        case FCS_MOVE_TYPE_FREECELL_TO_FREECELL:
                sprintf(string, "%c%c",
#ifndef FC89
                    ('a'+fcs_move_get_src_freecell(move)),
                    ('a'+fcs_move_get_dest_freecell(move))
#else
                    ('a'+Cvtf89(fcs_move_get_src_freecell(move))),
                    ('a'+Cvtf89(fcs_move_get_dest_freecell(move)))
#endif
					);                        
        break;

        case FCS_MOVE_TYPE_STACK_TO_FREECELL:
                sprintf(string, "%i%c",
                    1+fcs_move_get_src_stack(move),
#ifndef FC89
                    ('a'+fcs_move_get_dest_freecell(move))
#else
                    ('a'+Cvtf89(fcs_move_get_dest_freecell(move)))
#endif
                    );
//sprintf(szTemp, "StF fc-%d np-%d ", fcs_move_get_dest_freecell(move), NumFCs) ;
//MainMessage(szTemp) ;
		break;

        case FCS_MOVE_TYPE_STACK_TO_FOUNDATION:
			sprintf(string, "%ih", 1+fcs_move_get_src_stack(move));
			shind = TRUE ;
//MessageBox(GetFocus(), string, "S2F", MB_OK) ;
		break;
        

        case FCS_MOVE_TYPE_FREECELL_TO_FOUNDATION:
#ifndef FC89
				sprintf(string, "%ch", ('a'+fcs_move_get_src_freecell(move)));
#else
                sprintf(string, "%ch", ('a'+Cvtf89(fcs_move_get_src_freecell(move))));
#endif
				fhind = TRUE ;
//MessageBox(GetFocus(), string, "F2F", MB_OK) ;
        break;

        case FCS_MOVE_TYPE_SEQ_TO_FOUNDATION:
                sprintf(string, "%ih", fcs_move_get_src_stack(move));
        break;

        default:
            string[0] = '\0';
        break;
    }
    /* Restore that character */
	string[2] = c;
	b = string[0] ;  // Swap characters -- ABE
	string[0] = string[1] ;
	string[1] = b ;
//if (shind)
//MessageBox(GetFocus(), string, "S2F", MB_OK) ;
//shind = fhind = FALSE ;
}

static char * cmd_line_known_parameters[] = { NULL };

//int Free2Solver(Position * orig, int NoFcs, int limit, int mode, int option, char * * ret_moves)

int Free2Solver(Position * orig, int NoFcs, int limit, int cmd_line_argc, char * * cmd_line_argv,

	 int (*signal_step)(int step_limit))

{
    char * state_string;
    void * instance;
    int verdict;
    int num_iters;
    int ret;
    int current_limit = 1000;
    char * err_str;
    int ret_arg, parser_ret;
    state_string = position_to_string(orig, NoFcs);
    instance = freecell_solver_user_alloc();
	NumFCs = NoFcs ;
//sprintf(szTemp, "ac- %d ", cmd_line_argc) ;
//sprintf(szTemp, "ac- %d av-%s ", cmd_line_argc, cmd_line_argv[6]) ;
//MessageBox(GetFocus(), szTemp, "fcif", MB_OK) ;
    parser_ret = freecell_solver_user_cmd_line_parse_args(
            instance,
            cmd_line_argc,
            cmd_line_argv,
            0,
            cmd_line_known_parameters,
            NULL,
            NULL,
            &err_str,
            &ret_arg
            );
//MessageBox(GetFocus(), "Parsed", "fcif", MB_OK) ;
    if (parser_ret == FCS_CMD_LINE_UNRECOGNIZED_OPTION)
	{
MessageBox(GetFocus(), "Unrec", "fcif", MB_OK) ;
        freecell_solver_user_free(instance);        
        return 0;
    }
    freecell_solver_user_set_game(
        instance,
        NoFcs,
        8,
        1,
        FCS_SEQ_BUILT_BY_ALTERNATE_COLOR,
        0,
        FCS_ES_FILLED_BY_ANY_CARD
        );
    freecell_solver_user_limit_iterations(instance, current_limit);
#if 0
    freecell_solver_user_set_solving_method(
        instance,
        (((mode & 0xFFFF) == FCS_IFACE_MODE_DFS) ?
            FCS_METHOD_SOFT_DFS :
            FCS_METHOD_A_STAR
        )
    );
    freecell_solver_user_set_solution_optimization(
        instance,
        (mode & FCS_IFACE_MODE_OPT) ? 1 : 0
        );
#endif
    verdict = freecell_solver_user_solve_board(instance, state_string);
    free(state_string);
    while ((verdict == FCS_STATE_SUSPEND_PROCESS) && 
           (
                (limit > 0) ? 
                    (current_limit < limit) :
                    1
           )
          )
    {
//        if (signal_step(current_limit, signal_step_context) != 0)
        if (signal_step(current_limit) != 0)
        {
            break;
        }
        current_limit += 1000;
        freecell_solver_user_limit_iterations(instance, current_limit);
        verdict = freecell_solver_user_resume_solution(instance);
    }
    num_iters = freecell_solver_user_get_num_times(instance);
//    *ret_moves = NULL;
    if (verdict == FCS_STATE_WAS_SOLVED)
    {
        int num_moves;
        int a;
        fcs_move_t move;
#if 0   // Shlomi's new code
		char * str, * moves_string_proto, len;
        ret = num_iters;
        num_moves = freecell_solver_user_get_moves_left(instance);
        moves_string_proto = (char *)malloc(num_moves*4+1);

        /* a = num_moves-1; */

        str = moves_string_proto;
        while (! freecell_solver_user_get_next_move(instance, &move))
        {
            str = render_move(move, str);
        }
        len = str-moves_string_proto;
        moves_string = malloc(len+1);
        for(a=0;a<len;a++)
        {
            moves_string[a] = moves_string_proto[len-a];
        }
        moves_string[a] = '\0';
        free(moves_string_proto);
#if 0
        moves_string[num_moves*2] = '\0';
#endif
//        *ret_moves = moves_string;
#else   // restoration of old code
        ret = num_iters;
        num_moves = freecell_solver_user_get_moves_left(instance);
        moves_string = (char *)malloc(num_moves*2+1);
		moves_stringe = (char *)malloc(num_moves*2+1);
        a = num_moves-1;
		vcount = 0 ;
        while (! freecell_solver_user_get_next_move(instance, &move))
        {
//            render_move(move, moves_string + ((a-vcount)*2));
            render_move(move, moves_string + ((a)*2));
            a--;
//added by ABE for "v" mode
		if ((ssind == TRUE) && (fcs_move_get_num_cards_in_seq(move) > 1))
			{
			vcount++ ;
			moves_stringe = (char *)malloc((num_moves + vcount)*2+1);
			memcpy(moves_stringe+2, moves_string, (num_moves + vcount)*2) ;
			moves_string = (char *)malloc((num_moves + vcount)*2+1);
			memcpy(moves_string, moves_stringe, (num_moves + vcount)*2) ;
            render_vmove(move, moves_string + ((a+1)*2));
			}
//if (shind)
//MessageBox(GetFocus(), moves_string, "fcif", MB_OK) ;
//shind = FALSE ;
		}
//    moves_string[(num_moves + vcount)*2+2] = '\0';
		moves_string[(num_moves + vcount)*2] = '\0';

//        *ret_moves = moves_string;
#endif
	}
    else if (verdict == FCS_STATE_IS_NOT_SOLVEABLE)

    {

		if (num_iters == 0)

			num_iters++ ;

        ret = -num_iters;

    }

    else if ((verdict == FCS_STATE_SUSPEND_PROCESS) || (verdict == FCS_STATE_BEGIN_SUSPEND_PROCESS))

    {

        ret = 0;

    }

    

    freecell_solver_user_free(instance);



    return ret;

}



#if 1



static int my_signal_step(int step_limit)

{

    printf("num_iters=%i\n", step_limit);

    return 0;

}
#if 0
int main(int argc, char * argv[])

{

    Position mypos;

    int ret;



#include "fill_pos.cpp"



    ret = Free2Solver(&mypos, 4, 150000, argc-1, argv+1, my_signal_step);



    printf("%i\n", ret);



    printf("%s\n", moves_string);



    return 0;

}
#endif
#endif

