/* This is a callable version that reads boards in the format below
and solves them.  Link with (pat.o patsolve.o splay.o util.o). */

//#define IDIAG 1

#include "main.h"
//#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
//#include "patp.h"
#include "pat.h"
//#include "splay.h"
#include "param.h"

#include "fcsolve.h"
#include "freecell.h"

#define FC_CLUBS    (0 << 4)
#define FC_DIAMONDS (1 << 4)
#define FC_SPADES   (2 << 4)
#define FC_HEARTS   (3 << 4)

//static int FC_suit[] = { CLUBP, DIAMONDP, SPADEP, HEARTP };
//int FC_suit[] = { CLUBP, DIAMONDP, SPADEP, HEARTP };
int FC_suit[] = { PS_CLUB, PS_DIAMOND, PS_SPADE, PS_HEART };
//char Rank[] = "A23456789TJQK";
//char Suit[] = "CDHS";
char Suitp[] = "DCHS";
/*
int Total_positions, Total_generated ;
//int Interactive = TRUE; //
int Noexit = FALSE;     // -E means don't exit 
int Numsol;             // number of solutions found in -E mode 
int Stack = FALSE;      // -S means stack, not queue, the moves to be done 
int Cutoff = 1;         // switch between depth- and breadth-first 
int Status;             // win, lose, or fail 
int Quiet = FALSE;      // print entertaining messages, else exit(Status); 
int Xparam[NXPARAM];
double Yparam[NYPARAM];
*/
extern BOOL gbSearchF3 ;
//extern INT MaxMR ;
//extern BOOL won, spwinflag ;
//extern INT Total_positions_freed ;
//BOOL gb8fcps ;
extern void play(void) ;
extern void set_param(int) ;

char szTempA[50] ;
/*
typedef u_char Card;            // 00ssrrrr: s=suit, r=rank(1-13) 

typedef struct column_struct {
	u_char  count;          // number of cards in column 
	Card    cards[19];
} Column;

typedef struct pos_struct {
	u_char  foundations[4];
	Card    hold[8];
	Column  tableau[8];
} Position;
*/
char szTemp[60] ;
#ifdef IDIAG
char *cpre ;
char *cpost ;
#endif
long Mem_remain ;

//int Interactive = 0;    /* We're always in non-interactive mode. */

char rankp(char card)
{
	return card&0xf ;
}

char suitp(Card card)
{
	return card>>4 ;
}

static void convert_layout(Position *pos);

/* Pass in the position, the number of temp cells, the amount of
memory to use in megabytes, and the patsolve cutoff.  Returns either
WIN (0), NOSOL (1), or FAIL (-1).  The usual value for cutoff is 1. */


int patsub(Position *pos, int ntemp, int meg, int cutoff, char PatMode)
{
//FILE *doutfile ;
//Column *c;

	
	Same_suit = FALSE;
	King_only = FALSE;
	Nwpiles = 8;
	Ntpiles = ntemp;
	Cutoff = cutoff;
	Quiet = TRUE;

//	if (Ntpiles > MAXTPILES) {
//		msg("too many t piles (max %d)", MAXTPILES);
//		return FAIL;

	/* Initialize the suitable() macro variables. */

	Suit_mask = PS_COLOR;
	Suit_val = PS_COLOR;
	if (Same_suit) {
		Suit_mask = PS_SUIT;
		Suit_val = 0;
	}

	/* Reset stats. */

	Total_positions = 0;
	Total_generated = 0;
//	Total_positions_freed = 0 ;
//	Mem_remain = (meg+2) * 1024 * 1024 - sizeof(QUEUE);
	Mem_remain = (meg+2) * 1024 * 1024 - 50;
	/* Convert the initial layout. */

	Numsol = 0;
	convert_layout(pos);
//sprintf(szTempA, "1- %x 2-%x 3-%x 4-%x", W[1][1],W[1][2],W[1][3],W[1][4]) ;
//MessageBox(GetFocus(), szTempA, "CL", MB_OK) ;
	/* Go to it. */

	Status = NOSOL;
//	Status = -3 ; //for default
//MessageBox(GetFocus(), "Predoit", "PS", MB_OK) ;
#ifdef IDIAG
	cpre = malloc(10000);
	free(cpre) ;
#endif
//	doit();
	Interactive = FALSE ;
	Quiet = TRUE ;
	Same_suit = FALSE;
	King_only = FALSE;
	Nwpiles = 8;
//	Ntpiles = 4;
	Noexit = FALSE ;
	if (PatMode == 'S')
	{
		set_param(FreecellSpeed) ;
		Stack = TRUE ;
	}
	if (PatMode == 'T')
	{
		set_param(FreecellBest) ;
		Stack = FALSE ;
		Noexit = TRUE ;
	}
	if (PatMode == 'E')
	{
		set_param(FreecellSpeedt2) ;
		Stack = TRUE ;
	}
	if (PatMode == 'F')
	{
		set_param(FreecellSpeedt2A) ;
		Stack = TRUE ;
	}
	if (PatMode == 'B')
	{
		set_param(FreecellBest) ;
		Stack = TRUE ;
	}
	if (PatMode == 'A')
	{
		set_param(FreecellBestA) ;
		Stack = TRUE ;
	}
	play() ;
#ifdef IDIAG	
	cpost = malloc(10000);	
	free(cpost) ;
	if (cpost != cpre)
	{
		sprintf(szTemp, "pre=%d post=%d Statue=%d", cpre, cpost, Status);
	    MessageBox(GetFocus(), szTemp, "F3", MB_OK) ;
	}
#endif
	/* Clean up and return. */
	
//	sprintf(szTempA, "   Gen. %dK  Mem. Used %dM ", Total_generated/1000, meg-MaxMR) ;

#ifdef IDIAG
	cpre = malloc(10000);
	free(cpre) ;
#endif
//.	destroy();   ??? Not provided in 3.0
#ifdef IDIAG	
	cpost = malloc(10000);	
	free(cpost) ;
	if (cpost != cpre)
	{
		sprintf(szTemp, "preD=%d postD=%d Statue=%d", cpre, cpost, Status);
	    MessageBox(GetFocus(), szTemp, "F3", MB_OK) ;
	}
#endif
//sprintf(szTemp, "w= %d St= %d ",won, Status) ;
//MessageBox(GetFocus(), szTemp, "PSa", MB_OK) ;

	return Status;
}

/* Convert one card. */

static card_t convert_card(Card c)
{
	int suit, rank;

	if (c == 0) return NONE;
	suit = c >> 4;
	rank = c & 0xF;
	return FC_suit[suit] + rank;
}

/* Copy cards from the Position struct into the work arrays. */

static void convert_layout(Position *pos)
{
	int s, w, i;
	Column *c;

	/* Output piles. */

	for (i = 0; i < 4; i++) {
		s = suit(FC_suit[i]);   /* s is the suit of the input pile */
		O[s] = pos->foundations[i];
	}

	/* Temp cells. */

	for (i = 0; i < Ntpiles; i++) {
		T[i] = convert_card(pos->hold[i]);
	}

	/* Workspace. */

	for (w = 0; w < Nwpiles; w++) {
		c = &pos->tableau[w];
		for (i = 0; i < c->count; i++) {
			W[w][i] = convert_card(c->cards[i]);
		}
		Wp[w] = &W[w][c->count - 1];
		Wlen[w] = i ;
	}
if ((gnSolve != SOLVE_RANGE) && (gnSolve != SOLVE_LIST) && (!gbSearchF3))
	print_layout();
}

void printcard(card_t card, FILE *outfile)
{
//	if (rank(card) == NONE) {
//		fprintf(outfile, "   ");
//	} else	
	if (rankp(card) != NONE)
	{
		fprintf(outfile, "%c%c ", Rank[rankp(card)-1], Suitp[suitp(card)]);  //-1 added by ABE
	}
}

void print_layout()
{
	int i, t, w, o;
	card_t tm ;
FILE *outfile;
outfile = fopen( "pslayout.txt", "w" );
/*
	for (t = 0; t < Ntpiles; t++) {
//		printcard(T[t], stdout);
		printcard(T[t], outfile);
		fprintf(outfile, " ") ;
	}
	for (o = 0; o < 4; o++) {
//		printcard(O[o] + Osuit[o], stdout);
		printcard(O[o] + Osuit[o], outfile);
	}
//	putchar('\n');
fprintf(outfile, "\n") ;
*/
  for (w = 0; w < Nwpiles; w++) {
		for (i = 0; &W[w][i] <= Wp[w]; i++) {
//			printcard(W[w][i], stdout);
			printcard(W[w][i], outfile);
		}
//		putchar('\n');
	fprintf(outfile, "\n") ;
	}
	for (t = 0; t < Ntpiles; t++) {
//		printcard(T[t], stdout);
		printcard(T[t], outfile);
	}
	fprintf(outfile, "\n") ;
	for (o = 0; o < 4; o++) {
		tm = O[o] + Osuit[o] ;
//		printcard(O[o] + Osuit[o], stdout);
//		printcard(O[o] + Osuit[o], outfile);
		printcard(tm, outfile);
	}
//	putchar('\n');
fprintf(outfile, "\n") ;
//sprintf(szTemp, "%x %x %x %x", W[0][0], W[0][1],W[0][2],W[0][3]) ;
//MessageBox(GetFocus(), szTemp, "Layout", MB_OK) ;
fclose(outfile);
}
